import AbstractModel from './abstractModel'
import UserModel from './user'
import TaskModel from './task'

export default class BucketModel extends AbstractModel {
	constructor(bucket) {
		super(bucket)

		/** @type {number} */
		this.id

		/** @type {string} */
		this.title

		/** @type {number} */
		this.listId

		/** @type {number} */
		this.limit

		/** @type {TaskModel[]} */
		this.tasks = this.tasks.map(t => new TaskModel(t))

		/** @type {boolean} */
		this.isDoneBucket

		/** @type {number} */
		this.position

		/** @type {UserModel} */
		this.createdBy = new UserModel(this.createdBy)

		/** @type {Date} */
		this.created = new Date(this.created)

		/** @type {Date} */
		this.updated = new Date(this.updated)
	}

	defaults() {
		return {
			id: 0,
			title: '',
			listId: 0,
			limit: 0,
			tasks: [],
			isDoneBucket: false,
			position: 0,

			createdBy: null,
			created: null,
			updated: null,
		}
	}
}